//-----------------------------------------------------
// C6713 DSK  TLV320AIC23 g߂̔hNX
//      쐬ҁC쌠ҁF O㒼 2007/12/14
//-----------------------------------------------------
#ifndef MK_AIC23_6713

#include <dsk6713.h>
#include "AIC23_Base.hpp"

class AIC23_6713: public AIC23_Base
{
public:
    AIC23_6713(const AICfs fs_set = fs48kHz,
    		   const CACHE_L2Mode mode = CACHE_64KCACHE);
    inline void Read(float &chL, float &chR);
    inline void Read(float ch[]);           // ch[0]: , ch[1]: E
    inline void Write(const float chL, const float chR);
    inline void Write(const float ch[]);	// ch[0]: , ch[1]: E
    using AIC23_Base::Read;		// NX Read() g悤ɂ
    using AIC23_Base::Write;    // NX Write() g悤ɂ
};

// TLV320AIC23 ̐Kꂽf[^ǂݏo(f[^^: float)
// -1.0 <= f[^ < 1.0
inline void AIC23_6713::Read(float &chL, float &chR)
{
    Data3216 xn = AIC23_Read();
    chL = ((float)xn.chRL[1])*3.051758e-5f;
    chR = ((float)xn.chRL[0])*3.051758e-5f;
}

// TLV320AIC23 ̃f[^ǂݏo(f[^^: float [])
// -1.0 <= data < 1.0
inline void AIC23_6713::Read(float ch[])
{
    Data3216 xn = AIC23_Read();
    for (Int16 k=0; k<2; k++) ch[k] = ((float)xn.chRL[1-k])*3.051758e-5f;
}

// TLV320AIC23 ւ̐Kꂽf[^̏(f[^^: float)
// -1.0 <= data < 1.0
inline void AIC23_6713::Write(const float chL, const float chR)
{
    Data3216 yn;
    yn.chRL[1] = (Int16)(chL*32768.0f);
    yn.chRL[0] = (Int16)(chR*32768.0f);
    AIC23_Write(yn.buf);
}

// TLV320AIC23 ւ̐Kꂽf[^̏(f[^^: float [])
// -1.0 <= data < 1.0
inline void AIC23_6713::Write(const float ch[])
{
    Data3216 yn;
    for (Int16 k=0; k<2; k++) yn.chRL[1-k] = (Int16)(ch[k]*32768.0f);
    AIC23_Write(yn.buf);
}

#endif
#define MK_AIC23_6713
