//------------------------------------------------------------------------------
// C6713 DSK, C6416T DSK  TLV320AIC23 g߂̊NX
//      쐬ҁC쌠ҁF O㒼 2007/12/14
//------------------------------------------------------------------------------
#ifndef MK_AIC23_Base

#include <csl.h>        // CSL 𗘗pꍇCŏɂCN[h
#include <csl_cache.h>  // LbV̐ݒŎgp
#include <csl_mcbsp.h>  // McBSP ̐ݒCŎgp

class AIC23_Base
{
public:
    enum AICfs { fs96kHz = 0x001D, fs48kHz = 0x0001, fs44kHz = 0x0023,
                 fs32kHz = 0x0019, fs24kHz = 0x0041, fs16kHz = 0x0059,
                 fs08kHz = 0x000D, fs04kHz = 0x004D };
    void RegSet(const Uint16 reg, const Uint16 val);
// AiOMo͗po֐
    inline void Read(Int16 &chL, Int16 &chR);
    inline void Read(Int16 ch[]);           // ch[0]: , ch[1]: E
    inline void Write(const Int16 chL, const Int16 chR);
    inline void Write(const Int16 ch[]);    // ch[0]: , ch[1]: E
protected:
    AIC23_Base(const AICfs fs_set, const CACHE_L2Mode _mode,
               const Uint32 _block,
               const Uint32 _DXR, const Uint32 _DRR, const Uint32 _SPCR);
    void AIC_Set(const MCBSP_Handle _hCtrl, MCBSP_Config *mcbsp_ctrl,
                 const MCBSP_Handle hData, MCBSP_Config *mcbsp_data);
// TLV320AIC23 ̃f[^ɑΉ McBSP ̃WX^̃AhX
    const Uint32 DXR, DRR, SPCR;
// AiOMo͗po֐Ŏgp鋤L̂̐錾
    union Data3216 { Uint32 buf; Int16 chRL[2]; };

// TLV320AIC23  32 rbgf[^ McBSP ǂݏo
//  itO`FbNC|[ȌꍇɎgpj
    virtual Data3216 AIC23_Read() const
    {
        while ( 0x2 != (*(volatile Uint32 *)SPCR & 0x2));
        return *(Data3216 *)DRR;
    }
// TLV320AIC23 ւ 32 rbgf[^ McBSP ɏ
    void AIC23_Write(const Uint32 data) { *(Uint32 *)DXR = data; };
private:
    static bool created;            // IuWFNg̑d֎~̂
    const Uint16 fs;
    const CACHE_L2Mode mode;
    const Uint32 block;
    MCBSP_Handle hControl;          // TLV320AIC23 p McBSP ̃nh
    void Config();
};

// TLV320AIC23 ̃f[^ǂݏo(f[^^: Int16)
inline void AIC23_Base::Read(Int16 &chL, Int16 &chR)
{
    Data3216 xn = AIC23_Read();
    chL = xn.chRL[1];
    chR = xn.chRL[0];
}

// TLV320AIC23 ̐Kꂽf[^ǂݏo(f[^^: Int16 [])
inline void AIC23_Base::Read(Int16 ch[])
{
    Data3216 xn = AIC23_Read();
    for (Int16 k=0; k<2; k++) ch[k] = xn.chRL[1-k];
}

// TLV320AIC23 ւ̃f[^̏(f[^^: Int16)
inline void AIC23_Base::Write(const Int16 chL, const Int16 chR)
{
    Data3216 yn;
    yn.chRL[1] = chL;
    yn.chRL[0] = chR;
    AIC23_Write(yn.buf);
}

// TLV320AIC23 ւ̃f[^̏(f[^^: Int16 [])
inline void AIC23_Base::Write(const Int16 ch[])
{
    Data3216 yn;
    for (Int16 k=0; k<2; k++) yn.chRL[1-k] = ch[k];
    AIC23_Write(yn.buf);
}

#define MK_AIC23_Base
#endif
