//-----------------------------------------------------------------------
//      FFT gdێ@ɂ FIR tB^
//      | DSP/BIOS gpȂꍇ |
//          FFT ̃f[^F         256
//          FIR tB^̌W̐F 111 Fʉ߃tB^iLPFj
//                                   105 Fʉ߃tB^iHPFj
//-----------------------------------------------------------------------
#include "myDSK6713_DSP_BIOS.hpp"
#include <csl_irq.h>            // 荞ݗp CSL  API
#include "OLSclass.hpp"         // dێ@̂߂̃NX
#include "Timer.hpp"            // ^C}pNX
#include "MultiInt.hpp"         // d荞ݗpNX
#include "LargeLoad.hpp"        // 傫ȕׂ^邽߂Ɏgp
#include "Coefficients.hpp"     // tB^W

// AD/DA ϊpIuWFNg
AIC23_6713_DSP_BIOS codec; 

// ^C}荞ݗpIuWFNg̐ݒF
// timer0  CPU 荞ݔԍ 14 Ɋ蓖
const float TmCLK   = 56.25e6;  // ^C}쓮NbNgF225/4 MHz
const float PrdTInt = 0.2;      // ^C}荞݊ԊuF200 ms
Timer timer0(TIMER_DEV0, TmCLK*PrdTInt, IRQ_EVT_TINT0, 14);

// dێ@ FIR tB^̏sIuWFNg̐ݒ
// nLPF, hmLPF, nHPF, hmHPF  "Coeffients.hpp" ̒Œ`
const int nFFT = 256;           // FFT ̃f[^
OLS_FIR firLPF(nLPF, nFFT, hmLPF);  // LPF pIuWFNg
OLS_FIR firHPF(nHPF, nFFT, hmHPF);  // HPF pIuWFNg

// dێ@Ŏgϐ̏
volatile bool okLPF = false;    // LPF p
volatile bool okHPF = false;    // HPF p

//-----------------------------------------------------------------------
//                  main() ֐
//-----------------------------------------------------------------------
int main()
{
    IRQ_map(IRQ_EVT_RINT1, 11); // McBSP1M݂CPUݔԍ11ɐݒ
    IRQ_clear(IRQ_EVT_RINT1);   // McBSP1 MݗptONA
    IRQ_enable(IRQ_EVT_RINT1);  // McBSP1 M݂Cl[u

    short dummy;
    codec.Read(dummy, dummy);   // _~[ǂݏoCKs

    DSK6713_rset(DSK6713_USER_REG, 0);  // LED ̏
    timer0.Start();             // ^C}̃JEgJn
    IRQ_nmiEnable();            // m}XJu݁iNMIjL
    IRQ_globalEnable();         // O[oݗL

    while(true)                 // [v
    {
        if (okLPF)              // LPF ̌vZJnĂ悢mF
        {
            okLPF = false;
            firLPF.Execute();   // LPF ̌vZs
        }
        if (okHPF)              // HPF ̌vZJnĂ悢mF
        {
            okHPF = false;
            firHPF.Execute();   // HPF ̌vZs
        }
    }
}

//-----------------------------------------------------------------------
//    McBSP1 ̎M݁iINT11jɑ΂T[rX[`
//-----------------------------------------------------------------------
interrupt void AIC_RX_ISR()
{
    const int NmMp1LPF = nFFT - nLPF + 1;   // N-M+1CLPF p萔
    const int NmMp1HPF = nFFT - nHPF + 1;   // N-M+1CHPF p萔
    static int nXferLPF = NmMp1LPF;         // LPF p
    static int nXferHPF = NmMp1HPF;         // HPF p
    float xL, yL, xR, yR;

//----- Mo͂̏ -----
    codec.Read(xL, xR);         // AD ϊ킩
    yL = firLPF.BufIO(xL);      // `lFLPF ɑ΂o͏
    yR = firHPF.BufIO(xR);      // E`lFHPF ɑ΂o͏
    codec.Write(yL, yR);        // DA ϊ֏o

//----- f[^̓] -----
    if (--nXferLPF <= 0)        // LPF͗pobt@tɂȂ̊mF
    {
        nXferLPF = NmMp1LPF;
        okLPF = firLPF.Xfer();  // f[^̓]s
    }
    if (--nXferHPF <= 0)        // HPF͗pobt@tɂȂ̊mF
    {
        nXferHPF = NmMp1HPF;
        okHPF = firHPF.Xfer();  // f[^̓]s
    }
}

//-----------------------------------------------------------------------
//    TIMER0 ɑ΂銄݃T[rX[`
//    | ݎF 200 ms |
//-----------------------------------------------------------------------
interrupt void TIMER0_ISR()
{
    static short LEDs = 0;
    MultiInt m_int;             // 荞݂̃lXeBO

    DSK6713_rset(DSK6713_USER_REG, LEDs);
    LEDs = ++LEDs & 0xF;
    LargeLoad(300);             // 傫ȕ
}   // MultiInt ̃fXgN^̃[`̏IɎIɎs

