//----------------------------------------------------------------------------------
//      [U`ɂ Complex NX
//      Copyright (c) MIKAMI, Naoki 2005
//          2008/08/06: OԁgMyComplexhgp
//----------------------------------------------------------------------------------
#ifndef MK_MyComplex

#include <cmath>
#include "MyMath.hpp"

namespace MyComplex
{

    class Complex
    {
    private:
        float re, im;
    public:
        Complex(const float x = 0.0, const float y = 0.0)               // ftHgRXgN^
               : re(x), im(y) {}
        Complex(const Complex &z) : re(z.re), im(z.im) {}               // Rs[RXgN^
        float Real() const { return re; }                               // ̎擾io֐j
        float Imag() const { return im; }                               // ̎擾io֐j
        inline Complex &operator=(const Complex &x);                    // '=' ZqiEӒlF Complexj
        inline Complex &operator=(const float x);                       // '=' ZqiEӒlF float pj
        Complex operator- () const { return Complex(-re, -im); }        // PZq '-'

        friend float Real(const Complex &x) { return x.re; }            // ̎擾ith֐j
        friend float Imag(const Complex &x) { return x.im; }            // ̎擾ith֐j

// Z: '+'
        friend Complex operator+(const Complex &x, const Complex &y)    // Complex + Complex
            { return Complex(x.re + y.re, x.im + y.im); }
        friend Complex operator+(const Complex &x, const float y)       // Complex + float
            { return Complex(x.re + y, x.im); }
        friend Complex operator+(const float x, const Complex &y)       // float + Complex
            { return Complex(x + y.re, y.im); }

// Z: '-'
        friend Complex operator-(const Complex &x, const Complex &y)    // Complex - Complex
            { return Complex(x.re - y.re, x.im - y.im); }
        friend Complex operator-(const Complex &x, const float y)       // Complex - float
            { return Complex(x.re - y, x.im); }
        friend Complex operator-(const float x, const Complex &y)       // float - Complex
            { return Complex(x - y.re, -y.im); }

// Z: '*'
        friend Complex operator*(const Complex &x, const Complex &y)    // Complex * Complex
            { return Complex(x.re*y.re - x.im*y.im, x.re*y.im + x.im*y.re); }
        friend Complex operator*(const Complex &x, const float y)       // Complex * float
            { return Complex(x.re*y, x.im*y); }
        friend Complex operator*(const float x, const Complex &y)       // float * Complex
            { return Complex(x*y.re, x*y.im); }

// m, Ίp, f, t
        friend float Norm(const Complex &x)                             // mFΒl̂Q
            { return (x.re*x.re + x.im*x.im); }
        friend float Arg(const Complex &x)                              // Ίp
            { return std::atan2(x.im, x.re); }
        friend Complex Conj(const Complex &x)                           // f
            { return Complex(x.re, -x.im); }
        inline friend Complex Rcp(const Complex &x);                    // t
    };

//----------------------------------------------------------------------------------
//      o֐̒`
//----------------------------------------------------------------------------------
// '=' ZqiEӒlF Complexj
    inline Complex &Complex::operator=(const Complex &x)
    {
        re = x.re;
        im = x.im;
        return *this;
    }

// '=' ZqiEӒlF floatj 
    inline Complex &Complex::operator=(const float x)
    {
        re = x;
        im = 0.0;
        return *this;
    }

//----------------------------------------------------------------------------------
//      th֐̒`
//----------------------------------------------------------------------------------
// t
    inline Complex Rcp(const Complex &x)
    {
        float tmp = fInv(Norm(x));
        return Complex(x.re*tmp, -x.im*tmp);
    }

//----------------------------------------------------------------------------------
//      O[o֐̒`
//----------------------------------------------------------------------------------
// Βl
    inline float Abs(const Complex &x) { return fSqrt(Norm(x)); }

// exp(jx)
    inline Complex Expj(const float x) { return Complex(std::cosf(x), std::sinf(x)); }

}

#define MK_MyComplex
#endif
