//----------------------------------------------------------
//  User-defined mathematic routines for TMS320C67xx
//      fInv(), fInvSqrt(), fSqrt()
//      Copyright (c) MIKAMI, Naoki 2006
//----------------------------------------------------------
#ifndef MK_MyMath

inline float fInv(const float x);
inline float fInvSqrt(const float x);
inline float fSqrt(const float x);

// Reciplocal
inline float fInv(const float x)
{
    float y = _rcpsp(x);    // apploximation of 1/x
    for (int i=0; i<2; i++)
        y = y*(2.0f - x*y);
    return y;
}

// Reciplocal of sqrare root
inline float fInvSqrt(const float x)
{
    float y = _rsqrsp(x);   // approximation of sqrt(1/x)
    for (int i=0; i<2; i++)
        y = y*(1.5f - 0.5f*x*y*y);
    return y;
}

// Square root
inline float fSqrt(const float x)
{
    float y = (x != 0.0f) ? fInvSqrt(x) : 0.0f;
    return (x*y);
}

#define MK_MyMath
#endif
